=== debian/changelog ===
dietlibc (0.33~cvs20110918-4) unstable; urgency=low

  * d/rules: disable tc523086.c test on ARM (segfaults on armhf) 

 -- Hector Oron <zumbi@debian.org>  Fri, 07 Oct 2011 17:33:34 +0100

dietlibc (0.33~cvs20110918-3) unstable; urgency=low

  [ Thorsten Glaser ]
  * d/control: do not Recommend or Suggest the dietlibc package
    which is currently not built for any architecture
  * d/control: move homepage link from Description into its header

 -- Hector Oron <zumbi@debian.org>  Thu, 06 Oct 2011 13:51:39 +0100

dietlibc (0.33~cvs20110918-2) unstable; urgency=low

  * d/patches/fix-ppc64-ftbfs.diff: Fix FTBFS (Closes: #644405)
    - Thanks Hiroyuki Yamamoto for the fix

 -- Hector Oron <zumbi@debian.org>  Thu, 06 Oct 2011 13:17:24 +0100

dietlibc (0.33~cvs20110918-1) experimental; urgency=low

  [ Hector Oron ]
  * Update to cvs20110918. 
    - Fixes memchr('\0') (Closes: #582654)

  [ Thorsten Glaser ]
  * d/control: mention dynamic linking is currently disabled

 -- Hector Oron <zumbi@debian.org>  Sun, 18 Sep 2011 10:33:12 +0200

dietlibc (0.33~cvs20110710-2) experimental; urgency=low

  [ Hector Oron ]
  * Fix build for ARMv7 arches.
  * Fix FTBFS on s390. 
  * Drop 0015-arm-soft-and-hard-support.diff 

  [ Thorsten Glaser ]
  * d/diff/0017-disable-propolice: fix FTBFS on SSP-by-default gcc
  * d/diff/0018-manpage: fix manpage

 -- Hector Oron <zumbi@debian.org>  Sat, 17 Sep 2011 13:09:44 +0100
