=== debian/control ===
Source: dietlibc
Section: devel
Priority: optional
Homepage: http://www.fefe.de/dietlibc/
Maintainer: Hector Oron <zumbi@debian.org>
Uploaders: Gerrit Pape <pape@smarden.org>, Thorsten Glaser <tg@mirbsd.de>
Standards-Version: 3.9.2

Package: dietlibc-dev
Section: libdevel
Architecture: alpha amd64 arm armel armeb armhf hppa i386 ia64 mips mipsel powerpc ppc64 s390 sparc
Suggests: dietlibc-doc
Description: diet libc - a libc optimized for small size
 The diet libc is a C library that is optimized for small size. It
 can be used to create small statically linked binaries for Linux
 on alpha, arm, ia64, mips, mipsel, ppc, parisc, s390, sparc and x86.
 .
 This package is used to compile programs with the diet libc.
 .
 The diet libc also supports dynamic linking, but this has been
 temporarily disabled because of problems with it.

Package: dietlibc-doc
Architecture: all
Section: doc
Suggests: dietlibc-dev
Description: diet libc documentation - a libc optimized for small size
 The diet libc is a C library that is optimized for small size. It
 can be used to create small statically linked binaries for Linux
 on alpha, arm, ia64, mips, mipsel, ppc, parisc, s390, sparc and x86.
 .
 This package contains the documentation for the diet libc.
 .
 The diet libc also supports dynamic linking, but this has been
 temporarily disabled because of problems with it.
