## dietlibc 0.33~cvs20111108

=== debian/changelog ===
dietlibc (0.33~cvs20111108-5) unstable; urgency=low

  * Really fix s390 (Probably Closes: #523110)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 20 Nov 2011 16:52:41 +0000

dietlibc (0.33~cvs20111108-4) unstable; urgency=low

  [ Thorsten Glaser ]
  * “Schlösser Alt” upload
  * Patch to fix the ssize_t definition, for -Wformat benefit
  * Testcase to catch a specifically aligned strlen bug, from
    mtest-ascii1 of the Debian mksh package
  * Patch for string functions to not read past end of allocation
  * Patch to make strtod not use 'long double' on alpha, sparc
    (and sparc64) to make it link again (Closes: #547404)

  [ Bastian Blank ]
  * Patch to fix sigsetjmp on s390 (Closes: #523110)

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 19 Nov 2011 21:15:46 +0000

dietlibc (0.33~cvs20111108-3) unstable; urgency=low

  * The team of Héctor and me seems to have taken over well enough
    to close the ITA and drop Gerrit from Uploaders (Closes: #544060)
  * Upload to unstable
  * Enable s390x and sparc64 architectures, which are supported
    upstream, and see what happens

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 11 Nov 2011 18:06:11 +0000

dietlibc (0.33~cvs20111108-2) experimental; urgency=low

  * Remove parisc/strstr.S again (Closes: #523086)
  * Next attempt: use = instead of .equ or .set

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 10 Nov 2011 18:06:15 +0000

dietlibc (0.33~cvs20111108-1) experimental; urgency=low

  * debian/rules: New target "get-orig-source" to automate the
    process of exporting a CVS snapshot, without the CVS dirs,
    replace CR-LF line endings with LF ones, and tar it up
  * Update to cvs20111108
  * Use .equ instead of .set so it compiles on alpha
  * Honour nostrip for the diet* binaries, too (Closes: #436767)
  * Fix "debian/rules clean" not removing a ttt (test) binary
  * Make "lintian -vIiE --pedantic" clean
  * Repair ARM mmap syscall (Paul Brook, Timo Juhani Lindfors)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 08 Nov 2011 22:36:48 +0000

dietlibc (0.33~cvs20110918-5) experimental; urgency=low

  * Remove more mentions of the gone dynamic linking support
  * quilt refresh all patches
  * Pass -fno-stack-protector from diet to gcc when dietlibc is
    compiled without SSP support because otherwise programs will
    segfault, as dietlibc does not set up the registers needed
  * Re-enable tc523086, as I believe the testcase is right, and
    if an armhf buildd fails, the buildd is bad (Closes: #644646)
  * Fix all lintian warnings except CVS in orig.tar.gz
    - debian/copyright Format URI, fix format (spurious newline)
    - add comment to d/patches/0014-sparc_v9-does-not-imply-arch64
    - remove the .comment section when stripping binaries
  * Honour DEB_BUILD_OPTIONS=nostrip as well

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 03 Nov 2011 21:33:39 +0000
