=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Homepage: http://www.fefe.de/dietlibc/
 Maintainer: Hector Oron <zumbi@debian.org>
-Uploaders: Gerrit Pape <pape@smarden.org>, Thorsten Glaser <tg@mirbsd.de>
+Uploaders: Thorsten Glaser <tg@mirbsd.de>
 Standards-Version: 3.9.2
 
 Package: dietlibc-dev
 Section: libdevel
-Architecture: alpha amd64 arm armel armeb armhf hppa i386 ia64 mips mipsel powerpc ppc64 s390 sparc
+Architecture: alpha amd64 arm armeb armel armhf hppa i386 ia64 mips mipsel powerpc ppc64 s390 s390x sparc sparc64
 Suggests: dietlibc-doc
 Description: diet libc - a libc optimized for small size
  The diet libc is a C library that is optimized for small size. It
@@ -30,6 +30,3 @@
  on alpha, arm, ia64, mips, mipsel, ppc, parisc, s390, sparc and x86.
  .
  This package contains the documentation for the diet libc.
- .
- The diet libc also supports dynamic linking, but this has been
- temporarily disabled because of problems with it.
