=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,8 @@
 #!/usr/bin/make -f
+
+# for "debian/rules get-orig-source"
+ORIGTGZ_SOURCE:=	-D'2011/11/08 20:00'
+ORIGTGZ_DESTINATION:=	0.33~cvs20111108
 
 # determine whether we are cross-compiling
 DEB_BUILD_GNU_TYPE:=$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
@@ -45,28 +49,21 @@
 DIR =$(shell pwd)/debian/dietlibc
 VERSION =$(shell head -n1 debian/changelog |sed -e 's/.*(\(.*\)).*/\1/')
 
-patch: deb-checkdir patch-stamp
-patch-stamp:
-	for i in `ls -1 debian/diff/*.diff || :`; do \
-	  patch -p1 <$$i || exit 1; \
-	done
-	touch patch-stamp
-
 build: deb-checkdir build-stamp
-build-stamp: patch-stamp
-	#rm -f parisc/strstr.S
+build-stamp:
+	rm -f parisc/strstr.S
 	$(MAKE) prefix=/usr/lib/diet \
 	  MYARCH='$(ARCH)' VERSION='$(VERSION)' $(DEBUG)
 ifeq (${CROSS},0)
 	bin-'$(ARCH)'/diet -v -Os gcc -nostdinc -o ttt test/select.c
 	./ttt
 	rm -f ttt
-# Disable test on ARM (armhf segfaults)
-ifneq (,$(findstring arm,$(ARCH)))
 	bin-'$(ARCH)'/diet -v -Os gcc -nostdinc -static -o ttt debian/test/tc523086.c
 	./ttt
 	rm -f ttt
-endif
+	bin-'$(ARCH)'/diet -v -Os gcc -nostdinc -static -o ttt debian/test/t-ascii1.c
+	./ttt
+	rm -f ttt
 endif
 	test '$(DYN)' -eq 0 || \
 	  $(MAKE) dyn prefix=/usr/lib/diet \
@@ -75,9 +72,7 @@
 
 clean: deb-checkdir deb-checkuid
 	$(MAKE) clean MYARCH='$(ARCH)'
-	test ! -e patch-stamp || \
-	  for i in `ls -1r debian/diff/*.diff || :`; do patch -p1 -R <$$i; done
-	rm -f build-stamp install-stamp patch-stamp
+	rm -f build-stamp install-stamp ttt
 	rm -f dynlinker.README libdl.README libpthread.CHANGES \
 	  libpthread.README profiling.PORTING profiling.README \
 	  sparc64.README ia64.README changelog
@@ -106,8 +101,14 @@
 	install -d -m0755 '$(DIR)'-dev/usr/bin
 	mv '$(DIR)'-dev/usr/lib/diet/bin/diet* '$(DIR)'-dev/usr/bin/
 	ln -s ../../../bin/diet '$(DIR)'-dev/usr/lib/diet/bin/
-	strip '$(DIR)'-dev/usr/lib/diet/bin/dnsd
-	strip '$(DIR)'-dev/usr/lib/diet/bin/elftrunc
+ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
+	strip -s -R .comment '$(DIR)'-dev/usr/bin/diet
+	if test '$(DYN)' -eq 1; then \
+	  strip -s -R .comment '$(DIR)'-dev/usr/bin/diet-dyn; \
+	fi
+	strip -s -R .comment '$(DIR)'-dev/usr/lib/diet/bin/dnsd
+	strip -s -R .comment '$(DIR)'-dev/usr/lib/diet/bin/elftrunc
+endif
 	if test '$(DYN)' -eq 1; then \
 	  ln -s ../../../bin/diet-dyn '$(DIR)'-dev/usr/lib/diet/bin/ && \
 	  chmod 0644 '$(DIR)'/usr/lib/diet/lib/*.so && \
@@ -155,6 +156,30 @@
 	fi
 
 binary: binary-indep binary-arch
-.PHONY: patch build clean install binary-indep binary-arch binary
+.PHONY: build clean install binary-indep binary-arch binary
 
 include debian/implicit
+
+_ANONCVSROOT:=		:pserver:cvs@cvs.fefe.de:/cvs
+_CVSEXPORT:=		env CVS_RSH=ssh TZ=UTC cvs -qd ${_ANONCVSROOT} -z9 export
+ifneq (,$(wildcard /usr/bin/mircpio))
+_PACK:=			find dietlibc-${ORIGTGZ_DESTINATION} -type f | sort | \
+			    mircpio -oC512 -Hustar -Mdist
+else
+_PACK:=			tar -cf - dietlibc-${ORIGTGZ_DESTINATION}
+endif
+
+get-orig-source:
+	rm -rf $@.tmp
+	mkdir $@.tmp
+	# to get a Debian .orig.tar.gz we need to pull the source from CVS
+	cd $@.tmp; ${_CVSEXPORT} ${ORIGTGZ_SOURCE} dietlibc
+	# fixup files with CR-LF line endings
+	cd $@.tmp; find dietlibc -type f -print0 | \
+	    xargs -0 perl -pi -e 's/\r$$//' --
+	# then rename and pack it up
+	mv $@.tmp/dietlibc $@.tmp/dietlibc-${ORIGTGZ_DESTINATION}
+	cd $@.tmp; ${_PACK} | gzip -n9 >../dietlibc_${ORIGTGZ_DESTINATION}.orig.tar.gz
+	rm -rf $@.tmp
+	# there we are...
+	ls -l dietlibc_${ORIGTGZ_DESTINATION}.orig.tar.gz
