=== debian/changelog ===
dietlibc (0.33~cvs20120325-6) unstable; urgency=low

  * Team upload.
  * Upload to unstable
  * debian/watch: Update for new download location, 0.33 is out
  * Remove myself from Uploaders
  * debian/control: Use canonical VCS-* URI, says lintian

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 11 Feb 2014 21:48:06 +0100

dietlibc (0.33~cvs20120325-5) experimental; urgency=low

  [ Roland Stigge ]
  * Add support for the https://wiki.debian.org/PowerPCSPEPort
    (Closes: #694366)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 25 Nov 2012 21:41:02 +0000

dietlibc (0.33~cvs20120325-4) unstable; urgency=low

  [ Peter Michael Green ]
  * Tweak arm assembler patch so it works with armv6 vfp too.

  [ Thorsten Glaser ]
  * Fix jmp_buf size for armhf (Closes: #689222)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 30 Sep 2012 14:15:34 +0000

dietlibc (0.33~cvs20120325-3) unstable; urgency=low

  * Make the select testcase we run at build-time actually useful
  * Fix #394928 on ppc64, too (same patch, different directory)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 27 Mar 2012 20:18:03 +0000

dietlibc (0.33~cvs20120325-2) unstable; urgency=low

  * Upstream added a real mipsel port, use it instead of saying mips

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 26 Mar 2012 19:01:10 +0000

dietlibc (0.33~cvs20120325-1) unstable; urgency=low

  * Fix compile time warning (utimes undeclared) on armel, armhf, ia64
  * Policy 3.9.3 (no relevant changes)
  * Add VCS-* fields to debian/control
  * Take new upstream CVS snapshot (CVE-2012-1577)
  * Add -fno-strict-aliasing to files that emit a warning otherwise
  * Drop patches merged upstream

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 25 Mar 2012 15:52:21 +0000
