=== debian/control ===
--- 
+++ 
@@ -3,12 +3,13 @@
 Priority: optional
 Homepage: http://www.fefe.de/dietlibc/
 Maintainer: Hector Oron <zumbi@debian.org>
-Uploaders: Thorsten Glaser <tg@mirbsd.de>
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
+Vcs-git: git://anonscm.debian.org/collab-maint/dietlibc.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/dietlibc.git
 
 Package: dietlibc-dev
 Section: libdevel
-Architecture: alpha amd64 arm armeb armel armhf hppa i386 ia64 mips mipsel powerpc ppc64 s390 s390x sparc sparc64
+Architecture: alpha amd64 arm armeb armel armhf hppa i386 ia64 mips mipsel powerpc powerpcspe ppc64 s390 s390x sparc sparc64
 Suggests: dietlibc-doc
 Description: diet libc - a libc optimized for small size
  The diet libc is a C library that is optimized for small size. It
