=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,8 @@
 #!/usr/bin/make -f
 
 # for "debian/rules get-orig-source"
-ORIGTGZ_SOURCE:=	-D'2011/11/08 20:00'
-ORIGTGZ_DESTINATION:=	0.33~cvs20111108
+ORIGTGZ_SOURCE:=	-D'2012/03/25 15:00'
+ORIGTGZ_DESTINATION:=	0.33~cvs20120325
 
 # determine whether we are cross-compiling
 DEB_BUILD_GNU_TYPE:=$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
@@ -26,11 +26,11 @@
 ifeq ($(ARCH),powerpc)
   ARCH =ppc
 else
+ifeq ($(ARCH),powerpcspe)
+  ARCH =ppc
+else
 ifeq ($(ARCH),hppa)
   ARCH =parisc
-else
-ifeq ($(ARCH),mipsel)
-  ARCH =mips
 else
 ifneq (,$(findstring arm,$(ARCH)))
   ARCH =arm
@@ -162,12 +162,8 @@
 
 _ANONCVSROOT:=		:pserver:cvs@cvs.fefe.de:/cvs
 _CVSEXPORT:=		env CVS_RSH=ssh TZ=UTC cvs -qd ${_ANONCVSROOT} -z9 export
-ifneq (,$(wildcard /usr/bin/mircpio))
 _PACK:=			find dietlibc-${ORIGTGZ_DESTINATION} -type f | sort | \
-			    mircpio -oC512 -Hustar -Mdist
-else
-_PACK:=			tar -cf - dietlibc-${ORIGTGZ_DESTINATION}
-endif
+			    paxcpio -oC512 -Hustar -Mdist
 
 get-orig-source:
 	rm -rf $@.tmp
