=== debian/watch ===
version=3
http://www.fefe.de/dietlibc/ dietlibc-([0-9.]*)\.tar\.bz2
